% !TeX spellcheck = en_US
% !TeX encoding = UTF-8
% !TeX root = ../report.tex

\chapter{Appendix}
\label{chp:appendix}
\section{Activation functions} \label{app:activationfcts}
Activation functions in use:
\begin{figure}[h]
  \begin{subfigure}[t]{.4\textwidth}
    \centering
    \resizebox{\columnwidth}{!}{
        \begin{tikzpicture}
            \begin{axis}[
                    xmin=-0.7, xmax=1.7,
                    domain=-0.5:1.5, 
                    xtick={0},
                    ytick={0, 1},
                    grid style=dashed,
                    legend style={at={(0.95,0.05)},anchor=south east}
                ]
                \addplot[color=red, style=very thick]{x < 0 ? 0 : 1 };
                \addplot[color=blue, dashed]{(x+0.25) < 0 ? 0 : 1 };
                \addplot[color=blue, dashed]{(x-0.25) < 0 ? 0 : 1 };
                \legend{$0\text{ if }x<0\text{ else }1$\\ 
                        $0\text{ if }x-a<0\text{ else }1$\\}
            \end{axis}
        \end{tikzpicture}
    }
    \caption{Step Function}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.4\textwidth}
    \centering
    \resizebox{\columnwidth}{!}{
        \begin{tikzpicture}
            \begin{axis}[
                    xmin=-0.7, xmax=1.7,
                    domain=-0.5:1.5, 
                    xtick={0},
                    ytick={0, 1},
                    grid style=dashed,
                    legend style={at={(0.95,0.05)},anchor=south east}
                ]
                \addplot[color=red, style=very thick]{x < 0 ? 0 : (x < 1 ? x : 1) };
                \addplot[color=blue, dashed]{(x+0.25) < 0 ? 0 : ((x+0.25) < 1 ? (x+0.25) : 1) };
                \addplot[color=blue, dashed]{(0.5*x+0.25) < 0 ? 0 : ((0.5*x+0.25) < 1 ? (0.5*x+0.25) : 1) };
                \addplot[color=blue, dashed]{(x-0.25) < 0 ? 0 : ((x-0.25) < 1 ? (x-0.25) : 1) };
                \legend{$\text{min}(0\text{,} \text{max}(1\text{,}x))$\\
                        $\text{min}(0\text{,} \text{max}(1\text{,}b\cdot(x-a)))$\\}
            \end{axis}
        \end{tikzpicture}
    }
    \caption{modified RELU Function}
  \end{subfigure}

  \medskip

  \begin{subfigure}[t]{.4\textwidth}
    \centering
    \resizebox{\columnwidth}{!}{
        \begin{tikzpicture}
            \begin{axis}[
                    xmin=-2.3, xmax=2.3,
                    domain=-2:2, 
                    xtick={0},
                    ytick={0, 1},
                    grid style=dashed,
                    legend style={at={(0.95,0.05)},anchor=south east}
                ]
                \addplot[color=red, style=very thick]{1/(1+exp(-3*x))};
                \addplot[color=blue, dashed]{1/(1+exp(3*x))};
                \addplot[color=blue, dashed]{1/(1+exp(-1.5*x))};
                \addplot[color=blue, dashed]{1/(1+exp(-6*x))};
                \addplot[color=blue, dashed]{1/(1+exp(-3*(x-1)))};
                \addplot[color=blue, dashed]{1/(1+exp(-3*(x+1)))};
                \legend{$\frac{1}{1+e^{-x}}$\\$\frac{1}{1+e^{-b\cdot(x-a)}}$\\}
            \end{axis}
        \end{tikzpicture}
    }
    \caption{Sigmoid Function}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.4\textwidth}
    \centering
    \resizebox{\columnwidth}{!}{
        \begin{tikzpicture}
            \begin{axis}[
                    xmin=-2.3, xmax=2.3,
                    domain=-2:2, 
                    xtick={0},
                    ytick={0, 1},
                    grid style=dashed,
                    legend style={at={(0.95,0.05)},anchor=south east}
                ]
                \addplot[color=red, style=very thick]{e^(-1.5*x^2)};
                \addplot[color=blue, dashed]{e^(-6*x^2)};
                \addplot[color=blue, dashed]{e^(-0.5*x^2)};
                \addplot[color=blue, dashed]{e^(-1.5*(x-1)^2)};
                \addplot[color=blue, dashed]{e^(-1.5*(x+1)^2)};
                \legend{$e^{-x^2}$\\$e^{-b\cdot(x-a)^2}$\\}
            \end{axis}
        \end{tikzpicture}
    }
    \caption{Gaussian}
  \end{subfigure}
  \caption{Collection of activation functions, a: offset in x-direction, b: scaling factor in x-direction}
\end{figure}
\clearpage
\newpage
\section{Morphological operations}\label{app:morph}
Morphological operation are operations applied to a binary image $A$ using a structuring element $B$. 

\textbf{In this section, all equations are according to \cite{wikipedia_morph} and all images are take from \cite{opencv_morph}.}

\subsection{Erosion}
\begin{equation}
    A \ominus B = \{z\in E | B_{z} \subseteq A\}
\end{equation}
\begin{figure}[h]
    \centering
    \includegraphics[height=3cm]{images/app_morph/erosion.png}
    \caption{Left: original, right: eroded}
\end{figure}

\subsection{Dilation}
\begin{equation}
    A \oplus B = \bigcup_{b \in B} A_b
\end{equation}
\begin{figure}[h]
    \centering
    \includegraphics[height=3cm]{images/app_morph/dilation.png}
    \caption{Left: original, right: dilated}
\end{figure}

\subsection{Opening}
\begin{equation}
    A \circ B  = (A \ominus B) \oplus B
\end{equation}
\begin{figure}[h]
    \centering
    \includegraphics[height=3cm]{images/app_morph/opening.png}
    \caption{Left: original, right: opened}
\end{figure}

\subsection{Closing}
\begin{equation}
    A \bullet B = (A \oplus B) \ominus B
\end{equation}
\begin{figure}[h]
    \centering
    \includegraphics[height=3cm]{images/app_morph/closing.png}
    \caption{Left: original, right: closed}
\end{figure}


\section{Dilating Obstacles vs. Checking Area around Trajectory} \label{app:dil_vs_check}
It is much more efficient to dilate all obstacles by the model of the gokart, since this operation is rather simple. We then only have to check the intersection of the COG with the obstacle.
\begin{figure}[h]
  \begin{subfigure}[t]{.4\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/app_morph/MPCC_Overlay_Dil_obs.png}
    \caption{Dilating obstacles: easy via morph. operations, then only check the centerline}
  \end{subfigure}
  \hfill
  \begin{subfigure}[t]{.4\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/app_morph/MPCC_Overlay_Dil_path.png}
    \caption{checking area around each trajectory: expensive}
  \end{subfigure}
\end{figure}



